#region using
using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using System.Linq;
using System.Threading;
using System.Text.RegularExpressions;
#endregion

namespace Cotyounoyume{
	public class CycleManager
	{
		public float opening;
		public float closing1;
		public float closing2;
		public int state;
		
		public CycleManager(){
			
		}
		
		public void SetTimer(float openingTime, float closingTIme1, float closingTIme2){
			opening = openingTime;
			closing1 = closingTIme1;
			closing2 = closingTIme2;
		}
		
		public float GetProgress(float time){
			float delta;
			float result;
			if(time > closing2){
				result = (closing1 == closing2) ? 1.0f : 0.0f;
			}else if(time < closing1){
				delta = time - opening;
				result = Mathf.Lerp(0.0f, 1.0f, delta/(closing1 - opening));
//				result = delta / (closing1 - opening);
			}else if(time < closing2){
				delta = closing2 - time;
				result = Mathf.Lerp(0.0f, 1.0f, delta / (closing2 - closing1));
//				result = delta / (closing2 - closing1);
			}else{
				result = -1f;
			}
			return result;
		}

		public bool IsRising(float time){
			bool result;
			if(time < closing1){
				result = true;
			}else{
				result = false;
			}
			return result;
		}
		
		public int GetState(float time){
			if(time >= closing2){
				state = 0;
			}else if(time < closing1){
				state = 1;
			}else if(time < closing2){
				state = 2;
			}
			return state;
		}
	}
}